<!--
  ~ Copyright (c) 2024 LOBA
  ~ 
  ~ Permission is hereby granted, free of charge, to any person obtaining a copy of
  ~ this software and associated documentation files (the "Software"), to deal in
  ~ the Software without restriction, including without limitation the rights to
  ~ use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of
  ~ the Software, and to permit persons to whom the Software is furnished to do so,
  ~ subject to the following conditions:
  ~ 
  ~ The above copyright notice and this permission notice shall be included in all
  ~ copies or substantial portions of the Software.
  ~ 
  ~ THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  ~ IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS
  ~ FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR
  ~ COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER
  ~ IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
  ~ CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
  ~ 
  ~ SPDX-License-Identifier: MIT
  ~ 
  ~ Contributors:
  ~     [name] - [contribution]
-->

<template>
    <div class="user-item-line">
        <UserItem :data="user" :userDesignation="roleDesignation" />
        <div class="user-item-line-actions">
            <label class="form-group-checkbox">
                <input type="checkbox" :checked="hasPermission(1)"/>
                <div class="checkbox__checkmark"></div>
                <div class="checkbox__body">View</div>
            </label>
            <label class="form-group-checkbox">
                <input type="checkbox" :checked="hasPermission(2)"/>
                <div class="checkbox__checkmark"></div>
                <div class="checkbox__body">Edit</div>
            </label>
            <label class="form-group-checkbox">
                <input type="checkbox" :checked="hasPermission(3)"/>
                <div class="checkbox__checkmark"></div>
                <div class="checkbox__body">Share</div>
            </label>
        </div>
    </div>
</template>

<script setup lang="ts">
    const props = defineProps({
        user: Object,
        roles: Object
    });

    const hasPermission = (permissionId: number) => {
        return props.user && props.user.permissions.includes(permissionId);
    };

    const roleDesignation = computed(() => {
        if (!props.user || !props.roles) return '';
        const role = props.roles.find((role: any) => role.id === props.user?.role);
        return role ? role.role_designation : '';
    });

</script>